# FZ9D多路视频分时复用源码库

## 库程序

```sh
(base) ➜  src git:(master) ✗ tree 
── src
  ├── hdmi_capture_util.c
  ├── hdmi_capture_util.h
  ├── multi_channel_camera.cpp
  ├── multi_channel_camera.hpp
  ├── video_processor.c
  └── video_processor.h

0 directories, 6 files
```

`video_processor` : 通过MAC2MAC指令控制 拓展的视频处理器

`hdmi_capture_util` : V4L2采集的视频数据处理的工具函数

`multi_channel_camera` :  V4L2 接口封装，启动线程，采集图片 并通过回调函数返回数据

### 库编译

```sh
mkdir build
cd build
cmake ..
make
```

### 库安装

默认安装到目录：`out`

```sh
make install
```





## Demo程序

### fz9d_video_ctrl

通过json配置完成 网络 RTSP流 通道占比等信息的配置

#### 编译 

在库程序安装成功后，重新执行cmake

```sh
cd build
cmake ..
make fz9d_video_ctrl
```

#### 运行

```sh
./fz9d_video_ctrl ../demo/video.json
```



### fz9d_video_capture

简单的 多路视频采集调用demo

#### 编译

在库程序安装成功后，重新执行cmake

```
cd build
cmake ..
make fz9d_video_capture
```

#### 运行

1. 保证Fz9D 的Hi3536对应的网口与摄像头在同一个 局域网中
2. 通过 fz9d_video_ctrl 配置了正确的 rtsp 流

```sh
./fz9d_video_capture
```









### fz9d_video_capture_display 

多路视频采集 并通过显示器显示

通过鼠标 左右键或键盘的左右箭头可以切换当前显示的摄像头通道

#### 编译

在库程序安装成功后，重新执行cmake

```
cd build
cmake ..
make fz9d_video_capture_display
```

#### 运行

1. 保证Fz9D 的Hi3536对应的网口与摄像头在同一个 局域网中
2. 通过 fz9d_video_ctrl 配置了正确的 rtsp 流
3. 将显示器设置为 1280*720： `xrandr -s 1280x720`

```sh
./fz9d_video_capture_display
```



