#include "multi_channel_camera.hpp"

#include "display.hpp"
#include <chrono>
#include <iostream>
#include <memory>
#include <mutex>
#include <thread>
#include <unistd.h>

std::shared_ptr<Display> g_display;
std::shared_ptr<MultiChannelCamera> g_camera;
int read_cb(uint8_t ch_num, uint32_t frame_num, void *pdata, size_t size,
            int width, int height, void *user_data) {
    cv::Mat image(height, width, CV_8UC3, (unsigned char *)pdata);
    cv::Mat image_clone = image.clone();
    g_display->putFrame({image_clone, ch_num});
    return 0;
}

int main(int argc, char const *argv[]) {
    int ret = 0;
    g_display = std::make_shared<Display>("MultiChannelCaptureDemo");
    ret = g_display->start();
    if (ret != 0) {
        std::cout << "display start failed.\n";
        exit(-1);
    }

    g_camera = std::make_shared<MultiChannelCamera>("/dev/video1", read_cb,nullptr);
    ret = g_camera->start();
    if (ret != 0) {
        std::cout << "Cmaera start failed.\n";
        exit(-1);
    }

    while (1) {
        sleep(1);
        std::cout << "run ...\n";
    }

    g_camera->stop();
    return 0;
}
